
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>使用 Microsoft.NET Frameworks 创建Windows应用程序 / iVAN</title>

    <meta name="description" content="使用 Microsoft.NET Frameworks 创建Windows应用程序 window|程序|创建 使用 Microsoft.NET Frameworks 创建基于 Windows 的应用程序Shawn Burke Microsoft Corporation 2000年9月 摘要: :本文介绍了 Win 表单这一新的窗体程序包,借助这一程序包,开发人员能够充分利用 Microsoft Windows 操作系统所提供的 UI 功能. 目录 简介 介绍 Win Forms 更好的易学易用性 布局 GDI+ 访问底层系统 结论 -----------------------">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">使用 Microsoft.NET Frameworks 创建Windows应用程序</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>window|程序|创建</p>
<p>使用 Microsoft.NET Frameworks 创建基于 Windows 的应用程序<br />Shawn Burke <br />Microsoft Corporation <br />2000年9月</p>
<p>摘要： ：本文介绍了 Win 表单这一新的窗体程序包，借助这一程序包，开发人员能够充分利用 Microsoft Windows 操作系统所提供的 UI 功能。</p>
<p>目录</p>
<p>简介 <br />介绍 Win Forms <br />更好的易学易用性 <br />布局 <br />GDI+ <br />访问底层系统 <br />结论</p>
<p>--------------------------------------------------------------------------------</p>
<p>简介</p>
<p>目前 Web 已成了街谈巷议的话题，看起来好像 Microsoft Visual Studio 开发系统对创建基于 Microsoft Windows 的传统应用程序的支持有所减弱。实际上，Microsoft 对基于 Windows 的应用程序开发方面的投资在不断加大。</p>
<p>Win 表单是一个新的窗体程序包，借助这一程序包，开发人员能够充分利用 Microsoft Windows 操作系统所提供的丰富的用户界面功能，创建基于 Windows 的应用程序。Win Forms 是新的 Microsoft.NET 平台的一个组成部分，它提供了许多新技术，包括通用的应用程序框架、可管理的执行环境、一体化的安全性以及面向对象的设计原则。而且，Win Forms 全面支持快速简便地接入 Web Services 以及建立丰富的基于 ADO+ 数据模型的数据感知应用程序。得益于 Visual Studio 中新的共享开发环境，开发人员能够使用包括 Microsoft Visual Basic 和 C# 在内的任何支持 .NET 平台的语言创建 Win Forms 应用程序。</p>
<p>介绍 Win Forms</p>
<p>就像刚才所说的，Win Forms 是专用于 Windows 客户机 UI 编程的 .NET Framework 的命名空间。它与 ASP+ UI 程序包（即 Web Forms）共享同样的设计原则，但其类和实现却全然不同。在 Microsoft Win32 API 和 Web 组件之间没有魔术般变形的类。就像所有的 .NET Frameworks 一样，一致性已成为优先考虑的问题。其目的是为了 Win Forms 开发人员能够迅速适应在 Web Forms 中编写代码，反之亦然。例如，所有命名空间都有 Button 类，每一个都有文本、默认的 OnClick 事件以及 ForeColor、BackColor 和 Font 属性。</p>
<p>Win Forms 的所有控件都基于 System.WinForms.Control 类。Control 已内置了所有基本的 HWND 功能，并且它能处理我们已经熟悉并喜爱的绝大多数通用 WM_xxxx 消息。RichControl 由 Control 派生而来，其中添加了布局逻辑和绘图代码。System.WinForms 命名空间中的绝大多数控件实际上都由 RichControl 派生而来。ScrollableControl 能够支持窗口客户区域的滚动。一般情况下，对滚动功能的支持是通过 ContainerControl 实现的，后者由 ScrollableControl 派生而来，并增加了对管理子控件、焦点问题和跨栏的支持。Form 由 ContainerControl 派生而来，是 Win Form 的顶级控件，它带有控制标题栏、系统菜单、非矩形窗口和默认控件的属性。UserControl 也由 ContainterControl 派生而来，是开发人员能够创建的控件的基本类。UserControl 一般用于托管其它子控件，但对于外部客户机来说，它又是作为单个单元出现的。UserControl 和 Form 在 Microsoft Visual Studio.NET 中都有可视设计器，您会找到用于添加和设计由其所派生的类的项。</p>
<p>图 1. Win Forms 控件层次结构</p>
<p>既然我们已了解 Win Forms 的（最）基本方面，让我们揭开它的面纱，看看其表面下的一些相当不错的功能。</p>
<p>更好的易学易用性</p>
<p>Win Forms 的主要目的是尽可能地提高定位到 Win32 平台的开发人员的工作效率。无论是图形设备界面 (GDI) 还是窗口状态管理，为 Win32 编程通常都是很困难的。例如，类似 WS_BORDER 或 WS_CAPTION 的一些窗口样式只能在创建窗口时指定或修改。而 WS_VISIBLE 或 WS_CHILD 等其它窗口样式则可以对已创建的窗口进行修改。Win Forms 尽力消除了这些细微的差别，并确保操作过程始终保持一致性。可以随时地、不限次序地对 Win Forms 控件的属性进行设置，总能产生预期效果。如果改动过程需要创建新的 HWND，Win Forms 框架能够自动地、透明地重新生成窗口，并为其应用相适宜的所有设置。</p>
<p>由控件获得通知或事件在 Win Forms 中也要容易得多。Win Forms 事件都基于称为 Delegates 的一个通用语言运行时功能。Delegates 从本质上讲是对类型安全的、可靠的函数指针。对于任一控件的任一事件，都可以添加代理处理程序；绝不会强迫您创建派生类以通过替代处理事件，创建事件映射，或仅为处理一个事件而为类的所有事件实施一个接口。也可以通过替代派生类处理事件，但这种方式一般用于控件创建者或更为高级的应用。汇集某一按钮的 Click 事件相当简单：</p>
<p>public class ButtonClickForm: System.WinForms.Form {<br />private System.WinForms.Button button1;<br />public ButtonClickForm() {<br />// 创建按钮<br />button1 = new System.WinForms.Button();      <br />// 添加处理程序<br />button1.AddOnClick(new System.EventHandler(button1_Click));<br />// 将按钮添加到窗体中<br />this.Controls.Add(button1);<br />  }</p>
<p>private void button1_Click(object sender, EventArgs e) {<br />MessageBox.Show("button1 clicked!");<br />  }<br />    }</p>
<p>这里，我们创建了一个按钮，并添加了一个名为 button1_Click 的处理程序方法，通过短短几行代码，在单击该按钮后，将调用这一方法。请注意，即使处理程序方法被标记为专用，创建这一挂钩的代码仍可以使用该方法，单击按钮后，按钮将能够激活这一方法的事件。</p>
<p>启动 Win Forms 项目的过程也得到了简化。使用 Visual Studio.NET 创建 Win Forms 项目的过程只会创建一个要编译的项目文件：Form1.cs。没有头文件，没有接口定义文件，没有引导程序文件，没有资源文件，没有库文件。项目所需的所有信息都包含在窗体的代码中。这样做有一个好处：项目由一个简单的单窗体应用程序扩展到复杂的、带有多个代码文件的多窗体应用程序要方便得多。链接过程不需要中间对象文件，只有代码和已构建的、受管理的所有 DLL。只要您习惯了这一方法，就能明显地感觉到创建 .NET Framework 应用程序和创建 C/C++ 应用程序之间复杂性的不同。因为信息仅仅包含在代码文件中，在 Visual Studio.NET 环境外创建版本的过程也非常容易，无论是 Visual Basic 代码、C# 代码，还是任何其它语言编写的针对 .NET Framework 的代码。</p>
<p>因为 Win Forms 建立在通用语言运行时的基础之上，开发人员可以任选目前针对通用语言运行时的众多语言中的一种，构建 Win32 应用程序。开发人员现在可以使用多种语言编写 Win Forms 应用程序（或 Web Forms 应用程序或 Data 应用程序）：从 C# 到 COBOL 到 Eiffel 再到 Perl 等等，中间还有很多种（上一次计数是 17 种）。方便易用再加上广泛的应用场合相得益彰，为开发人员提供了深厚的基础，使他们能够迅速有效地使用 Win Forms 构建实用的应用程序。</p>
<p>布局</p>
<p>如果您曾尝试创建能够正常调整大小的窗体，您就会知道这一过程有多么困难。Microsoft Foundation Classes (MFC) 或早期的 Visual Basic 版本没有对这一功能提供内置的支持。然而现在只需几行代码（通常情况下您甚至不需要编写这些代码，因为在设计时就能通过 Property Browser 实现这些功能！），即可创建能够正常调整大小的对话框。</p>
<p>基本布局由两条组成：Anchoring 和 Docking。RichControl 有一个 Anchor 属性，它是一种枚举类型，可以用“或”操作将这些值组合在一起，以说明控件将与其父控件的某一边保持恒定距离。例如，如果您将一个按钮置于窗体上，并将 Anchor 属性设置为 AnchorStyles.BottomRight，则在调整按钮的大小时，按钮将与窗体的底边和右边保持同一距离。此外，如果将 Anchor 设置为 AnchorStyles.All，则按钮的各个边都与窗体的对应边保持同一距离，在调整按钮大小时仍要满足这些约束条件。</p>
<p>Docking 实际上是 Anchoring 的一个特殊情况。RichControl 的 Dock 属性说明控件要将自身固定到其父控件的哪一边。Docking 可以是 Top、Left、Right、Bottom 或 Fill。在每种情况下，控件都将移动到尽量靠近指定边，并调整其大小，以填满那一边。如果父控件的大小有所调整，这一状况仍将保持。将一个控件移动到父控件的底端，并将 Anchor 设置为 AnchorStyle.BottomLeftRight，可以模拟 Docking Bottom。在此处的示例中，列表框是 Docked Left，按钮与窗体的顶端、左边和右边保持恒定距离，由此它们保持了相对位置和大小。下面的示例对话框（图 2）完全使用 Visual Studio.NET 中的 Win Forms 设计器创建，只花了两分钟的时间，没有编写一行代码。</p>
<p>图 2. 使用 Win Forms 设计器所创建的可调整大小的对话框</p>
<p>// ResizableSample.cs<br />namespace ResizableSampleNamespace {</p>
<p>using System;<br />using System.Drawing;<br />using System.ComponentModel;<br />using System.WinForms;</p>
<p>/// &lt;summary&gt;<br />///    ResizableSample 的摘要说明。<br />/// &lt;/summary&gt;<br />public class ResizableSample : System.WinForms.Form {<br />/// &lt;summary&gt; <br />///    为 Win Forms 设计器所要求 <br />/// &lt;/summary&gt;<br />private System.ComponentModel.Container components;<br />private System.WinForms.Button button3;<br />private System.WinForms.Button button2;<br />private System.WinForms.Button button1;<br />private System.WinForms.ListBox listBox1;<br />public ResizableSample() {<br />// 为 Win Form 设计器支持所要求<br />InitializeComponent();</p>
<p>}</p>
<p>/// &lt;summary&gt;<br />///    释放正在使用的所有资源<br />/// &lt;/summary&gt;<br />public override void Dispose() {<br />base.Dispose();<br />components.Dispose();<br />        }</p>
<p>/// &lt;summary&gt;<br />///    应用程序的主入口点。<br />/// &lt;/summary&gt;<br />public static void Main(string[] args) {<br />Application.Run(new ResizableSample());<br />        }</p>
<p>/// &lt;summary&gt;<br />        ///    设计器支持所要求的方法 — 不要用编辑器<br />        ///    修改这一方法的内容<br />/// &lt;/summary&gt;<br />private void InitializeComponent()<br />   {<br />this.components = new System.ComponentModel.Container();<br />this.button2 = new System.WinForms.Button();<br />this.button3 = new System.WinForms.Button();<br />this.button1 = new System.WinForms.Button();<br />this.listBox1 = new System.WinForms.ListBox();<br />//@design this.TrayLargeIcon = false;<br />//@design this.TrayHeight = 0;<br />this.Text = "Resizable Dialog";<br />this.IMEMode = System.WinForms.IMEMode.Off;<br />this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);<br />this.ClientSize = new System.Drawing.Size(256, 173);<br />button2.Location = new System.Drawing.Point(152, 60);<br />button2.Size = new System.Drawing.Size(92, 32);<br />button2.TabIndex = 2;<br />button2.Anchor = System.WinForms.AnchorStyles.TopLeftRight;<br />button2.Text = "Cancel";<br />button3.Location = new System.Drawing.Point(152, 120);<br />button3.Size = new System.Drawing.Size(92, 44);<br />button3.TabIndex = 3;<br />button3.Anchor = System.WinForms.AnchorStyles.All;<br />button3.Text = "Filler";<br />button1.Location = new System.Drawing.Point(152, 8);<br />button1.Size = new System.Drawing.Size(92, 32);<br />button1.TabIndex = 1;<br />button1.Anchor = System.WinForms.AnchorStyles.TopLeftRight;<br />button1.Text = "OK";<br />listBox1.Size = new System.Drawing.Size(120, 173);<br />listBox1.Dock = System.WinForms.DockStyle.Left;<br />listBox1.TabIndex = 0;<br />listBox1.Items.All = new object[] {"Item One",<br />"Item Two",<br />"Item Three",<br />"Item Four"};<br />this.Controls.Add(button3);<br />this.Controls.Add(button2);<br />this.Controls.Add(button1);<br />this.Controls.Add(listBox1);<br />   }</p>
<p>}<br />}</p>
<p>GDI+</p>
<p>Win Forms 全面利用了 GDI+ 这一 Microsoft 下一代的二维图形系统。Win Forms 中的图形编程模式完全是面向对象的，各式各样的画笔、笔刷、图像和其它图形对象与 .NET Framework 的其它部分一样，遵循了简单易用的指导方针。开发人员目前可以使用相当不错的一些绘图新功能，如 alpha 混色、渐变色、纹理、消除锯齿以及采用除位图外的其它图像格式。与 Windows 2000 操作系统分层和透明的窗口功能配合使用，开发人员能够毫不费力地创建丰富的、更为图形化的 Win32 应用程序。</p>
<p>如果触发了控件的 OnPaint 事件，能够由 PaintEventArgs 访问的 System.Drawing.Graphics 对象就成为一个 GDI+ 图形对象。图形对象能够执行的所有操作都通过 GDI+ 实施。作为一个示例，使用 GDI+ 创建一个绘制渐变背景的按钮。</p>
<p>图 3. 使用 GDI+ 创建的按钮</p>
<p>以下是实现这一按钮的代码：</p>
<p>public class GradientButton : Button {<br />// 保留颜色设置的成员<br />private Color startColor;<br />private Color endColor;</p>
<p>// 书写文字时我们将需要它<br />private static StringFormat format = new StringFormat();<br />public GradientButton() : base() {<br />// 初始化颜色 <br />startColor = SystemColors.InactiveCaption;<br />endColor = SystemColors.ActiveCaption;<br />format.Alignment = StringAlignment.Center;<br />format.LineAlignment = StringAlignment.Center;<br />    }</p>
<p>/// &lt;summary&gt;<br />/// 渐变色的终止颜色<br />// &lt;/summary&gt;<br />public Color EndColor {<br />get {<br />return this.endColor;<br />         }<br />set {<br />this.endColor = value;<br />// 如有必要，则导致重新绘制<br />if (this.IsHandleCreated &amp;&amp; this.Visible) {<br />Invalidate();<br />            }<br />         }<br />   }</p>
<p>/// &lt;summary&gt;<br />/// 渐变色的起始颜色<br />// &lt;/summary&gt;<br />public Color StartColor {<br />get {<br />return this.startColor;<br />         }<br />set {<br />this.startColor = value;<br />// 如有必要，则导致重新绘制<br />if (this.IsHandleCreated &amp;&amp; this.Visible) {<br />Invalidate();<br />           }<br />        }<br />   }</p>
<p>protected override void OnPaint(PaintEventArgs pe) {<br />// 绘制按钮的常规背景以形成 <br />// 边框，等等。              <br />base.OnPaint(pe);<br />Graphics g = pe.Graphics;<br />Rectangle clientRect = this.ClientRectangle;<br />// 缩小矩形，以免绘制时出界<br />clientRect.Inflate(-1,-1);<br />// 创建渐变笔刷，从<br />// 左上角运行到右下角。<br />Brush backgroundBrush = new LinearGradientBrush(<br />new Point(clientRect.X,clientRect.Y), <br />new Point(clientRect.Width, clientRect.Height), <br />startColor, <br />endColor);<br />// 以渐变色填充背景....<br />g.FillRectangle(backgroundBrush, clientRect);<br />// 在客户机区域的中间书写文字。<br />g.DrawString(this.Text, <br />this.Font, <br />new SolidBrush(this.ForeColor), <br />clientRect, <br />format);<br />   }<br />}</p>
<p>就像您所看到的，这并不是非常困难。得益于 Win Forms 和 GDI+ 面向对象的设计，无需编写任何复杂的代码，即可实现我们的 GradientButton，并且在设计器中，可以通过 Property Browser 操作 Text、Font、StartColor 和 EndColor。</p>
<p>访问底层系统</p>
<p>许多框架的一个缺点就是：如果人们编写的应用程序类型与示例和演示中的严格一致，则这些框架的效果相当不错，但有时开发人员发现，一旦他们希望用框架进行一些有创造性的工作，某些情况下就会碰到障碍或遭到失败。如果遇到这一情况，Win Forms 框架自始至终都能够允许开发人员访问系统基础结构。当然，希望 Win Forms 这样一个设计优良的框架不会使用户遭遇这种情况，但可能发生的情况几乎是无限的。所有的控件都有 Handle 属性，允许访问控件的窗口句柄 (HWND)，GDI 对象也提供了类似的句柄访问过程。而且，Control 实际上拥有一个名为 WndProc 的受保护的虚拟方法，对于少数 Win Forms 尚不能支持的消息，可以替代该方法，添加处理方式。</p>
<p>例如，假设您的应用程序是资源密集型的，需要响应 WM_COMPACTING。如果系统检测到内存不足，会向所有高层窗口广播 WM_COMPACTING，您就会知道 Win Forms 框架对这一消息没有提供内置支持，由此，可以添加如下处理过程：</p>
<p>/// &lt;summary&gt;<br />///    Win32Form1 的摘要说明。<br />/// &lt;/summary&gt;<br />public class CompactableForm : System.WinForms.Form {<br />private EventHandler handler;<br />public void AddOnCompacting(EventHandler h) {<br />handler = (EventHandler) Delegate.Combine(handler, h);<br />}</p>
<p>protected override void OnCompacting(EventArgs e) {<br />// 查看运行时系统能否释放任何东西<br />System.GC.Collect();<br />// 调用任一处理程序。<br />if (handler != null) handler(this, e);<br />   }</p>
<p>public void RemoveOnCompacting(EventHandler h) {<br />handler = (EventHandler) Delegate.Remove(handler, h);<br />}</p>
<p>protected override void WndProc(ref Message m) {<br />case (m.msg) {<br />case win.WM_COMPACTING:<br />OnCompacting(EventArgs.Empty);<br />break;<br />      }<br />base.WndProc(m);<br />   }</p>
<p>}</p>
<p>只需数行代码，当系统试着收集未用资源时，利用新的 CompactableForm 类或由此派生的类即可得到通知，并作出响应。</p>
<p>结论</p>
<p>尽管在许多开发人员的计划中，针对 Web 的开发是当前工作的重点，而定位于熟悉的 Win32 平台仍然是一个不得不面对的情况。有了 Win Forms，Windows 开发人员无论是新手还是老手，都会发现使用丰富的接口创建复杂的应用程序是一个很方便的过程，而这些接口与 .NET Framework 中具有 Web 和数据功能的许多技术配合良好。</p>
<p>通过利用跨语言继承、碎片收集和安全性等通用语言运行时提高工作效率的优秀功能，开发人员将从 .NET Framework 和 Win Forms 中获益。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-08 05:20:14</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ba%94%e7%94%a8%e7%a8%8b%e5%ba%8f/" title="应用程序">应用程序</a>, <a href="https://www.iamivan.net/tag/win/" title="win">win</a>, <a href="https://www.iamivan.net/tag/button/" title="button">button</a>, <a href="https://www.iamivan.net/tag/%e6%8e%a7%e4%bb%b6/" title="控件">控件</a>, <a href="https://www.iamivan.net/tag/system/" title="system">system</a>, <a href="https://www.iamivan.net/tag/forms/" title="forms">forms</a>, <a href="https://www.iamivan.net/tag/%e4%bb%a3%e7%a0%81%e5%ba%94%e7%94%a8win32%e5%af%b9%e8%af%9d%e6%a1%86/" title="代码应用win32对话框">代码应用win32对话框</a>, <a href="https://www.iamivan.net/tag/button%e7%82%b9%e5%87%bb%e5%90%8e%e5%8f%98%e8%89%b2/" title="button点击后变色">button点击后变色</a>, <a href="https://www.iamivan.net/tag/%e6%8c%89%e9%92%aewinform/" title="按钮winform">按钮winform</a>, <a href="https://www.iamivan.net/tag/winform%c2%a0%e5%bc%80%e5%8f%91%e9%81%87%e5%88%b0%e9%97%ae%e9%a2%98/" title="winform&nbsp;开发遇到问题">winform&nbsp;开发遇到问题</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>使用 Microsoft.NET Frameworks 创建Windows应用程序的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YbKaV7p.html" rel="bookmark">使用Microsoft&period;NET Frameworks创建Windows应用程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				window|程序|创建 使用 Microsoft.NET Frameworks 创建基于 Windows 的应用程序 Shawn Burke Microsoft Corporation 2000年9月 摘要: :本文介绍了 Win 表单这一新的窗体程序包,借助这一程序包,开发人员能够充分利用 Microsoft Windows 操作系统所提供的 UI 功能. 目录 简介 介绍 Win Forms 更好的易学易用性 布局 GDI+ 访问底层系统 结论 ----------------------			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOl5vQb.html" rel="bookmark">win32-关于 visual studio 2010 创建 windows 应用程序问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于 visual studio 2010 创建 windows 应用程序问题 想用2010创建 windows 应用程序,选项 是否生成文件清单 改成否也不行.总是出现 1&gt;------ 已启动全部重新生成: 项目: Ex1-03, 配置: Debug Win32 ------ 1&gt;生成启动时间为 2015/7/4 22:47:32. 1&gt;_PrepareForClean: 1&gt; 正在删除文件&quot;DebugEx1-03.lastbuildstate&quot;.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr2EJmM.html" rel="bookmark">使用 Microsoft&period;NET Frameworks 创建基于 Windows 的应用程序（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要: :本文介绍了 Win 表单这一新的窗体程序包,借助这一程序包,开发人员能够充分利用 Microsoft Windows 操作系统所提供的 UI 功能.目录 简介 介绍 Win Forms 更好的易学易用性 布局 GDI+ 访问底层系统 结论 --------------------------------------------------------------------------------简介 目前 Web 已成了街谈巷议的话题,看起来好像 Microsoft Visual S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdyR9xz.html" rel="bookmark">从创建一个应用程序到制作一个安装包的详细过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				创建 Windows 应用程序在&quot;文件&quot;菜单上指向&quot;新建&quot;,然后选择&quot;项目&quot;. 在&quot;新建项目&quot;对话框中,选择&quot;项目类型&quot;窗格中的&quot;Visual Basic 项目&quot;,然后选择&quot;模板&quot;窗格中的&quot;Windows 应用程序&quot;.在&quot;名称&quot;框中,键入&quot;我的记事本&quot;. 此项目被添加到解决方案资源管理器中,并且窗体设计器打开			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYkDarz.html" rel="bookmark">JavaScript与C&num; Windows应用程序交互方法&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.建立网页 &lt;html&gt; &lt;head&gt;       &lt;meta http-equiv=&quot;Content-Language&quot; content=&quot;zh-cn&quot;&gt;       &lt;script language=&quot;javascript&quot; type=&quot;text/javascript&quot;&gt;              &lt;!-- 提供给C#程序调用的方法 --&gt;           			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJ7rD8b.html" rel="bookmark">如何在Microsoft Visual Studio 2005中创建控制台应用程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 Visual Studio 2005 中创建控制台应用程序 在 Visual Studio 2005 中的&quot;文件&quot; 菜单上,指向&quot;新建&quot; 并单击&quot;项目&quot;. 在&quot;新建项目&quot; 对话框中,选择一种语言,然后在&quot;项目类型&quot; 框中选择&quot;Windows&quot;. 在&quot;模板&quot; 框中,选择&quot;控制台应用程序&quot; . 在&quot;位置&quot; 框中,键入指向应用程序			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOmQ59M.html" rel="bookmark">C&num;通过创建Windows服务启动程序的方法详解&lowbar;C&num;教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了C#通过创建Windows服务启动程序的方法.分享给大家供大家参考,具体如下: 1. 新建一个Windows服务应用程序 创建项目--&gt;Visual C# 左侧的&quot;+&quot;--&gt;Windows --&gt;Windows 服务(右侧模板)--&gt;输入名称,确定创建项目 2. 设置Windows服务的属性(Windows服务里没有窗体,所以点击左侧设计器里空白的地方即可在右侧属性栏里看到属性) 这里属性是控制服务器是否可以停止,暂停,继续等等的操作.根据需要选择			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6NgxyM.html" rel="bookmark">windows窗体应用程序-刚刚安装了Netbeans8&period;1，要创建窗体应用程序，但是找不到</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 刚刚安装了Netbeans8.1,要创建窗体应用程序,但是找不到 刚刚安装了Netbeans8.1,要创建窗体应用程序,但是找不到,自己百度搜索了好久还是找不到解决办法..请指教 解决方案 http://wenku.baidu.com/link?url=ICCGblJl50kcRuiko5cE8OiW8INzCUv0YcJbw_dGHMnGbzneiMg42JPcbuypZmq63VB92rbA6cxKQL-NIpM9yjO2xYR2q-k9zmDMascMK3m			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRreap.html" rel="bookmark">比较windows phone程序启动和android程序启动原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				windows phone 程序是如何启动的了,他和android程序有什么区别,我们重点从native code 层面来分析  在windows phone 程序启动的时候是: 在XAML中使用应用程序定义指定起始Page(它是启动 WindowsPhone7程序时自动加载的Page). 指定方法是将 StartupUri 属性设置为所需的 Page 的 统一资源标识符 (URI). 可以在标记中以声明方式设置 StartupUri,如下面的示例所示. &lt;Application     xml			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkwgop.html" rel="bookmark" class="title">怎样设置无线路由器密码不被万能钥匙破解</a>
					<div>
						  首先用网线把无线路由器和电脑连起来,输入192.168.1.1打开无线路由器的设置页面,登录. 打开后,在无线设置这里,打开无线安全设置,如图. 里面有3种模式的安全设置,最上面推荐的这个WPA- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPBGqb.html" rel="bookmark" class="title">Photoshop调出婚纱样片高质量肤色效果</a>
					<div>
						  从这张照片中可以看出这是以哥德式建筑,红砖嵌条墙的教堂为背景拍摄的一张作品,但是美中不足的是原片裙摆曝光过度导致丢失了细节,还有头发的层次感也不够完美,以及画面中大面积的露白天空等等,但是正是因为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5OEBb.html" rel="bookmark" class="title">30分钟学会正则表达式基础教程</a>
					<div>
						基础教程|教程|正则表达式|正则 目录 本文目标 如何使用本教程 正则表达式到底是什么? 入门 测试正则表达式 元字符 字符转义 重复 字符类 反义 替换 分组 后向引用 零宽断言 负向零宽断言 注释 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqovaz.html" rel="bookmark" class="title">为什么网站排名长期没变化</a>
					<div>
						网络优化是一般人做不好的工作,做站长的谁不是满满的耐心呢?因为选择这个行业之处,我们就知道,最需要的是静下心来坚持差不多的工作.对于我们而言,网站排名很重要,但是呢,为什么做那么久网站排名一直没什么变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKVoOz.html" rel="bookmark" class="title">有BitMap之Menu</a>
					<div>
						在Window API中,有一些名词要先清楚,假设有一功能表如下: 档案 编辑 选项 --&gt; hMenu (功能表) +-------+ |复制 |---------&gt; hSubMenu  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7P78b.html" rel="bookmark" class="title">css代码格式化清理工具</a>
					<div>
						 &lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOa9jqM.html" rel="bookmark" class="title">任务栏&OpenCurlyDoubleQuote;安全删除硬件&rdquo;里出现删除硬盘驱动器C，D怎么去掉</a>
					<div>
						平时在使用电脑时,常常会在任务栏&quot;安全删除硬件&quot;里出现删除硬盘驱动器C,D,E,F和光驱,本教程就为大家提供解决方法. 故障现象: 任务栏&quot;安全删除硬件&quot;里出现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5o2jRb.html" rel="bookmark" class="title">Mac入门教程：U盘格式兼容Win及OS X怎么设置</a>
					<div>
						  Mac入门教程:U盘格式兼容Win及OS X怎么设置?在目前的环境中,用户会经常在 Win 及 OS X 之间交互,主要有以下几种使用情景: (1).需长期存储数据,较少交互; (2).经常交互, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkG1ZEp.html" rel="bookmark" class="title">win7系统打开网络属性提示&OpenCurlyDoubleQuote;部分控件被禁用&rdquo;的解决方法</a>
					<div>
						  随着计算机的普及,网络已是我们生活中不可缺少的,当然在使用网络时遇到的各类问题也随着增多,不少用户反映在设置win7网络属性时,出现&quot;部分控件被禁用&quot;的窗口提示,对于出现该问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3kjyp.html" rel="bookmark" class="title">phonegep在ios下的页面上下划动问题</a>
					<div>
						问题描述 phonegep在ios下的页面上下划动问题 如何 禁止掉这种拉伸,不影响页面本身的滚动条 解决方案 本身页面显示就是基于一个webview,所以只要关闭webview的滚动就好了					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YWeXM.html" rel="bookmark" class="title">php 微信 教务网-在微信公众平台中如何模拟有验证码的教务网进行抓取所需要的信息</a>
					<div>
						问题描述 在微信公众平台中如何模拟有验证码的教务网进行抓取所需要的信息 我想代码可以用php实现,使用其中的curl函数库.由于没有过模拟有验证码网页的经验,所以希望大家能讲讲其中的一些细节,最好回答 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQ4OOp.html" rel="bookmark" class="title">OPEN CASCADE Multiple Variable Function</a>
					<div>
						OPEN CASCADE Multiple Variable Function eryar@163.com Abstract. Multiple variable function with grad ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKEq3b.html" rel="bookmark" class="title">知道DShowNET的请进&period;一个简单的问题&period;</a>
					<div>
						问题描述 DShowNET大家知道是一个图型接口,但我只看到定义的接口,而没看到有实现的类.类似这样:publicinterfaceIMediaControl{[PreserveSig]intRun( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M947Kgb.html" rel="bookmark" class="title">新版《包青天》今开机金超群何家劲16年后再聚</a>
					<div>
						[提要] 16日,安徽卫视投资的第三版&lt;包青天&gt;正式开机,已年过半百的金超群.何家劲.范鸿轩等原班人马继续担大梁主演.另据投资方透露,王莎莎.张少华.唐国强也将参演,唐国强可能演皇帝一角. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWoj8z.html" rel="bookmark" class="title">url-datatable的sAjaxSource问题</a>
					<div>
						问题描述 datatable的sAjaxSource问题 想利用datatable的sAjaxSource 重新附一个url,并且url后边带上一个自定义的参数,代码如下: searchCsOrTsR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4am6z.html" rel="bookmark" class="title">《锋利的SQL（第2版）》&mdash;&mdash;1&period;3 Transact-SQL语言的类型</a>
					<div>
						1.3 Transact-SQL语言的类型 锋利的SQL(第2版) 在介绍了SQL的起源后,来看一下Transact-SQL包括哪些语言类型.首先,为了遵循ANSI SQL标准,Transact-SQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYGrLp.html" rel="bookmark" class="title">C&num; 在picturebox画线，画矩形，当需要擦除其中某一条曲线的时候怎么做？用异或画笔？？这方面了解比较少，求大神。。。</a>
					<div>
						问题描述 C#在picturebox画线,画矩形,当需要擦除其中某一条曲线的时候怎么做?用异或画笔??这方面了解比较少,求大神... 解决方案 解决方案二:这个,你只能做层,PS软件都没办法做到这点除 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgKkWM.html" rel="bookmark" class="title">SQL SERVER 监控数据文件增长情况</a>
					<div>
						   在项目前期评估数据库的增长情况,然后根据数据库数据量的增长情况来规划存储的分配其实是一件比较麻烦的事情.因为项目没有上线,用什么来评估数据库的数 据增长情况呢? 如果手头没有实际的数据,我们只能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJq407p.html" rel="bookmark" class="title">刘国梁和张继科 现身轻奢手机品牌HANMAC新品BON7发布会</a>
					<div>
						北京时间2016年11月7日下午,轻奢手机品牌HANMAC在上海西班牙中心,举办了发布品牌战略暨轻奢手机万元机新品BON7发布会.HANMAC的CEO钱慰萱女士,在发布会上对现场500多位嘉宾分享了H ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeogBAM.html" rel="bookmark" class="title">盘点国内类Path应用</a>
					<div>
						一.Path简介 Path是由前Facebook高管Dave Morin本人创建的简单而且是私密的社交网络.而Path的新版是从原有的分享照片平台,让服务内容不再只局限于照片分享,让用户能够可以分享一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXAVBb.html" rel="bookmark" class="title">《Hadoop与大数据挖掘》一2&period;3&period;5　动手实践：运行MapReduce任务</a>
					<div>
						2.3.5 动手实践:运行MapReduce任务 实验步骤如下: 1)上传/root/anaconda-ks.cfg文件到HDFS文件系统/user/root目录: 2)使用yarn jar的方式提交 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boL856M.html" rel="bookmark" class="title">利用JavaScript实现新闻滚动效果&lpar;实例代码&rpar;&lowbar;javascript技巧</a>
					<div>
						最近要实现一个滚动新闻效果,在网上查了一些资料,发现基本的实现方法有两种: 1.使用Marquee标签.这个标签的使用我已经转载了一篇比较详细的文章,这个标签的优点是便于使用,缺点是人们已经逐渐不适用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNm5A7b.html" rel="bookmark" class="title">《例说8051：单片机程序设计案例教程》&mdash;&mdash;2-2　8051的输入&sol;输出口</a>
					<div>
						2-2 8051的输入/输出口 MCS-51迷人的地方之一,就在于其四个输入/输出口!这四个看似相同的输入/输出口其实还是有点差异的,说明如下. Port 0 Port 0为8位.可位寻址的输入/输出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqgvGKz.html" rel="bookmark" class="title">怎样获取一个文本框在页面上的位置信息？</a>
					<div>
						问题描述 我有一个文本框,下面还有一个DIV,我想让DIV绝对定位在文本框的下面,因为如果相对定位的话,文本框下面的按钮之类的会被DIV撑走.我想让DIV浮在这些按钮之上并定位在文本框之下.不知道怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjoK4mM.html" rel="bookmark" class="title">KK：现在是史上最佳的创业时机</a>
					<div>
						摘要: 你能想象1985年的时候创业环境有多棒吗?那时候,所有的词,短的.酷的,几乎任何你想要的.com域名都能要得到.你所要的做只是去问.甚至连域名声明也不需要花钱.这样的大好机 你能想象1985年 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zG17P3M.html" rel="bookmark" class="title">DedeCms实现文章关键词关连文章、自动内链的方法</a>
					<div>
						一.找到:系统-&gt;系统基本参数-&gt;性能选项-&gt;使用关键词关连文章-&gt;选&quot;是&quot;   二.找到:核心-&gt;批量维护-&gt;文档关键词维护          ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmRQXDz.html" rel="bookmark" class="title">启源装备明日网上路演</a>
					<div>
						启源装备(300140)顺利结束在深圳.上海和北京三地初步询价及路演推介工作.今日公司刊登网上路演公告,将于10月29日举行网上路演. 公司从事变压器专用设备及组件的设计.开发.制造.销售.服务,是拥 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPOZPDM.html" rel="bookmark" class="title">聊天里的发图片  这么查看大图片</a>
					<div>
						问题描述 在聊天过程中 发送的图片  然后点击图片  就崩溃了  ,这里需要这么配置啊??????? 解决方案 那你看下环信demo中 EaseChatRowImage这个类中 onBubbleCli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWK3kGM.html" rel="bookmark" class="title">电话诈骗骗得700多万</a>
					<div>
						一个以台湾人为首的犯罪团伙仅在广州就骗了21人 本报珠海讯 记者林丹 报道:珠海警方成功侦破一特大电话诈骗案,涉案金额700多万元.该团伙仅在广州就诈骗21人,骗得赃款500多万元,最大一宗诈骗248 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQaXk0b.html" rel="bookmark" class="title">英国著名探险家Felicity Aston独自一人成功穿越南极大陆</a>
					<div>
						2012年1月22日,英国著名探险家Felicity Aston独自一人成功穿越南极大陆,创造了一项新的世界纪录.她的成功登顶,预示着http://www.aliyun.com/zixun/aggre ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
